Foreman - Bug #1350

Mysql2::Error: BLOB/TEXT column ‘title’ used in key specification without a key length
11/23/2011 07:33 AM - Telmo X

Status: Closed
Priority: Normal
Assignee: Sam Kottler
Category: DB migrations

Target version:

1.1

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:

Pull request:

Description

| get this error when trying to migrate the DB for the first time (clean install)

some info in the system:

sh-3.2# /opt/comcast/platform/rubyee/bin/ruby -v

ruby 1.8.7
03

(2011-02-18 patchlevel 334) [x86_64-1inux], MBARI 0x6770, Ruby Enterprise Edition 2011.

sh-3.2# 1lsb_release -a

LSB Version:

:core—-4.0-amd64:core-4.0-1ia32:core-4.0-noarch:graphics-4.0-amd64:graphics-4.0-1ia32

:graphics-4.0-noarch:printing-4.0-amd64:printing-4.0-ia32:printing-4.0-noarch
Distributor ID: RedHatEnterpriseServer

Description: Red Hat Enterprise Linux Server release 5.6 (Tikanga)
Release: 5.6

Codename: Tikanga

sh-3.2#

I've tried to trace the offending migration, but my rails is a little "rusty" and | haven't been able to find where the index is being
created.

My config file is standard, puppet reports have not been added (trying to stand up foreman prior to dealing with puppet)

#:modulepath: /etc/puppet/modules/

:tftppath: tftp/

#:rrd_report_url: report/

#:1dap: true

#your default puppet server - can be overridden in the host level

#if none specified, plain "puppet" will be used.
:puppet_server: dcavm-nb-18p.sys.comcast.net

#:unattended: false

#use the following setting to override the default 30 minutes puppet run interval - value must be
in minutes

60

/var/www

#:puppet_interval:
#:document_root:

sh—-3.2# RAILS_ENV=production rake db:drop

(in /opt/comcast/platform/foreman/foreman)

sh-3.2# RAILS_ENV=production rake db:create

(in /opt/comcast/platform/foreman/foreman)

sh-3.2# RAILS_ENV=production rake db:migrate —--trace
(in /opt/comcast/platform/foreman/foreman)

* % (first_time)

(first_time)

Invoke db:migrate

** Invoke environment

** Execute environment

** Execute db:migrate
== CreateHosts: migrating
rake aborted!
An error has occurred, all later migrations canceled:

Mysqgl2::Error: BLOB/TEXT column 'title' used in key specification without a key length: CREATE IN
DEX ‘index_resources_on_title_and_restype’ ON resources  ( title’, “restype’)
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/connection_adapt
ers/abstract_adapter.rb:227:in " log'
/opt/comcast/platform/rubyee/lib/ruby/gems/1.8/gems/mysql2-0.2.6/1ib/active_record/connection_adap
ters/mysql2_adapter.rb:314:in “execute'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/connection_adapt
ers/abstract/schema_statements.rb:292:in " add_index'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:352
:in " send’
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:352
:in "method_missing'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:328
:in “say_with_time'

/opt/comcast/platform/rubyee/lib/ruby/1.8/benchmark.rb:293:in “measure'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:328
:in “say_with_time'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:348
:in "method_missing'
/opt/comcast/platform/rubyee/lib/ruby/gems/1.8/gems/puppet-2.7.6/1ib/puppet/rails/database/schema.
rb:28:in “init'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/schema.rb:47:1in
“instance_eval'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/schema.rb:47:in
‘define'’
/opt/comcast/platform/rubyee/lib/ruby/gems/1.8/gems/puppet-2.7.6/1ib/puppet/rails/database/schema.
rb:8:in “init'
/opt/comcast/platform/rubyee/lib/ruby/gems/1.8/gems/puppet-2.7.6/1ib/puppet/util.rb:180:in "benchm
ark'

/opt/comcast/platform/rubyee/lib/ruby/1.8/benchmark.rb:308:1in "realtime'
/opt/comcast/platform/rubyee/lib/ruby/gems/1.8/gems/puppet—-2.7.6/1lib/puppet/util.rb:179:in “benchm
ark'
/opt/comcast/platform/rubyee/lib/ruby/gems/1.8/gems/puppet-2.7.6/1ib/puppet/rails/database/schema.
rb:4:in “init’

./db/migrate//20090714132448_create_hosts.rb:8:in ‘up_without_benchmarks'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:282
:in " send'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:282
:in "migrate’

/opt/comcast/platform/rubyee/lib/ruby/1.8/benchmark.rb:293:in “measure'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:282
:in "migrate'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:365
:in ~__send_ '
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:365
:in "migrate'’
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:491
:in ‘migrate'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:567
:in “call!
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:567
:in “ddl_transaction'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:490
:in "migrate’
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:477
:in “each’
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:477
:in "migrate'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:401
:in Tup'
/opt/comcast/platform/foreman/foreman/vendor/rails/activerecord/lib/active_record/migration.rb:383
:in "migrate'’
/opt/comcast/platform/foreman/foreman/vendor/rails/railties/lib/tasks/databases.rake:112
/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.

1 _chain'

/opt/comcast/platform/rubyee/lib/ruby/1.8/monitor.rb:242:in
/opt/comcast/platform/rubyee/lib/ruby/gems/1.8/gems/rake-0.8.

1_chain'

/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.

tion_handling'

/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.

tion_handling'

/opt/comcast/platform/rubyee/lib/ruby/gems/1.
/opt/comcast/platform/rubyee/lib/ruby/gems/1.

/opt/comcast/platform/rubyee/bin/rake:19:in
/opt/comcast/platform/rubyee/bin/rake:19
sh-3.2#

8/gems/rake-0.
8/gems/rake-0.
8/gems/rake-0.
8/gems/rake-0.
8/gems/rake-0.

8/gems/rake-0.
8/gems/rake-0.
8/gems/rake-0.
8/gems/rake-0.
8/gems/rake-0.
8/gems/rake-0.

8/gems/rake-0.
8/gems/rake-0.
8/gems/rake-0.

8/gems/rake-0.
8/gems/rake-0.
“load'

O 0 0 00 0o

QO 0 0 0 00 0o

[ee]

.7/1ib/rake.
.7/1ib/rake.
.7/1lib/rake.
.7/1lib/rake.
.7/1ib/rake.

.7/1ib/rake.
.7/1lib/rake.
.7/1lib/rake.
.7/1ib/rake.
.7/1ib/rake.
.7/1ib/rake.

.7/1ib/rake.
.7/1ib/rake.
.7/1lib/rake.

.7/1ib/rake.
.7/bin/rake:

‘synchronize'
7/1lib/rake.rb:

rb

31

rb:
rb:
rb:
rb:
rb:

rb:
:2051:
2029:
2029:

2029:
2068:

rb:
rb:
rb:
rb:

rb:
rb:
rb:

rb:

636:

636: 1

631:
631:

597:1

590:

583:

2023:
2001:1
2068:

1998:1

in
in
in
in
in

in

in

in
in
in
in
in
in
in

in

in

“call'

“execute'

“each'

‘execute'
‘invoke_with_cal

“invoke_with_cal

“invoke'

“invoke_task'
“top_level'!
“each'
“top_level'!

" standard_excep

“top_level!
“run'

“standard_excep

‘run

Associated revisions

Revision dbdc8726 - 12/19/2012 08:38 AM - Trey Dockendorf
- Allows mysql2 usage with Puppet < 2.7.10 - Fixes #1350

History

#1 - 11/23/2011 07:37 AM - Telmo X

| forgot to add that this is foreman 0.4 from http:/theforeman.org/attachments/download/298/foreman-0.4.tar.bz2 because | don't have a standard

bury installation | can't instal the rpm

#2 - 11/23/2011 07:43 AM - Ohad Levy

- Status changed from New to Feedback

tracing it back to db/migrate/20090714132448_create_hosts.rb line 8 seems to be related to puppet internals.

| would suggest try with mysqgl gem not mysql2 (i never tried it with mysql2).

check the version of active record that you have installed, maybe its too new for puppet.

#3 - 11/23/2011 04:25 PM - Telmo X

changing from mysql2 to mysql did the trick. maybe something worth documenting.

#4 - 12/02/2011 01:51 AM - Ohad Levy
- Target version deleted (0.4.1)

according to http:/stackoverflow.com/questions/5255234/is-it-possible-to-use-gem-mysql2-with-rails-2-3 (and many others) rails 2.3.x might have a

few issues with the mysql2 gem.

since we already moved to rails3 (in the develop branch), if you are interested, you could give it another try.

Thanks

#5 - 07/02/2012 06:47 AM - Ohad Levy

can we close this one?

thanks

#6 - 11/15/2012 09:59 AM - Sam Kottler
http://theforeman.org/attachments/download/298/foreman-0.4.tar.bz2
http://stackoverflow.com/questions/5255234/is-it-possible-to-use-gem-mysql2-with-rails-2-3

- Status changed from Feedback to Closed
- Assignee set to Sam Kottler

- Target version set to 1.1
This is fixed in the develop branch now and slated for release in 1.1. Thanks!

#7 - 12/15/2012 12:41 PM - Trey Dockendorf

- Status changed from Closed to Assigned

I just ran into this with 1.1RC1. This fixed it for me. See https://groups.google.com/d/topic/foreman-users/NIJzvScgZZ8/discussion

diff --git a/db/migrate/20090714132448_create_hosts.rb b/db/migrate/20090714132448_create_hosts.rb
index e7e7923..£029466 100644
——— a/db/migrate/20090714132448_create_hosts.rb
+++ b/db/migrate/20090714132448_create_hosts.rb
@@ -4,7 +4,7 Q@ class CreateHosts < ActiveRecord::Migration
# we are only creating the full database if the hosts table doesn't exists, if it does, we assume that st
ore config is already configured
unless Host.table_exists?
require 'puppet/rails/database/schema’
- Puppet [ :dbadapter]= ActiveRecord: :Base.configurations[RAILS_ENV] ["adapter"]
+ Puppet [ :dbadapter]= ActiveRecord::Base.configurations[RAILS_ENV] ["adapter"].sub ("mysgl2", "mysqgl")
Puppet::Rails::Schema.init
Puppet::Rails.migrate ()
end

#8 - 12/19/2012 09:27 AM - Anonymous
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset dbdc87269f48345a582a793b1714e1439b2fed29.
